abstract class ParametricCurve
{
  ParametricCurve( color _c, float _w, int _N, float _offsetX, float _offsetY )
  {
    c = _c;
    w = _w;
    N = _N;
    offsetX = _offsetX;
    offsetY = _offsetY;
  }  
  
  ParametricCurve()
  {
    c = color( 255, 0, 0 );
    w = 2.0;
    N = 256;
    offsetX = 0.0;
    offsetY = 0.0;
  }
  
  void draw()
  {
    noFill();
    strokeWeight( w );
    stroke( c );
    
    beginShape();
    for ( int i=0; i<=N; ++i )
    {
      float t = lerp( a, b, i / float( N ) );
      PVector pt = eval( t );
      
      vertex( pt.x + offsetX, pt.y + offsetY );
    }
    endShape();
  }
  
  abstract PVector eval( float t );
  
  // [a,b] is the interval that we plot
  float a;
  float b;
  // c is the plot color
  color c;
  // w is the plot line width
  float w;
  // N is the number of line segments used for drawing
  int   N;
  // offset is how much we offset the in X and Y when plotting it
  float offsetX;
  float offsetY;
}
